/*
  This program is free software published under the
  terms of the GNU Lesser General Public License.
  http://www.gnu.org/copyleft/lesser.html    
  This program is distributed in the hope that it will
  be useful - WITHOUT ANY WARRANTY; without even the
  implied warranty of MERCHANTABILITY or FITNESS FOR A
  PARTICULAR PURPOSE.
*/ 


/*  xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
     coded in ECMAScript 5 - JavaScript 5  (ES5, ECMAScript 2009)
    xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx */


//  xxxxxxxxxxxxxxx   wm12 variable declarations  xxxxxxxxxxxxxxxx


// These variables below can be directly modified by the user on the options form: 

var lc = 16;       // minimum visible shapes

var hc = 16;     // maximum visible shapes

var wc = 1;    // number of item within each level between lc..hc
    
var emoji = true;   // stimulus generator. if (emoji) => draw E-moji, else draw geometric shapes

var tcolor = true;   //  if (tcolor==true) all colors will be used (full random colors). if (tcolor==false) => only basic html colors are used 

var is_back = false;    // if (is_back==true) => user can go back to previous task/item  

var is_forward = false;  // if (is_forward==true) => user can escape (skip) items. Next task/item button vill be visible. 

var demo = false;       // if (demo == true) => show correct solution with "X"

var timer = 600;     // Task time in seconds if clock = 1000ms (default). 

var timer_enabled = false;   // if true => timer is enabled. if false timer is disabled. Exactly: the timer is always on

var prg_type = "2";   //  type of information in Progress Bar 

var store = false;    // false => this web application will not store results within client web browser.; true => This web application will store the results inside client web browser. 


// Other wm12 variables and constants:

var itemCnt;       // total item count    

var clock = 1000;  // basic timer resolution in ms. Default = 1s (1000ms)

var timer_id = null;   // timer_id is the identifier of the repeated action you want to cancel. This ID is returned from setInterval().

var counter = 0;      // timer counter. if (counter >= time) Timer will call theEnd()   

var item = 0;   // current item      

var rad= [];       // array of shapes radius for each item (level)

var dirty = false;  // if  (dirty==true) => user changed any options in form 

var is_task = false;    // task in progress or not  (for timer)
      
/*  stim = jagged array= [item][shape] =>
[
[0]= x; [1]= y;  [2]= shape type; [3]= color; [4]= selected or not selected; [5]= cell is done (closed) or not done (open); 
]*/
var stim = [];  

var stim_b = [];        // canvas bounds for each item => stim_b =>  [0] = left; [1] = top; [2] = right; [3]= bottom

// array values constants for Emoji drawings:
// var arr = [8986, 8987, 9200, 9748, 9749, 9875, 9917, 9924, 9925, 9940, 9962, 9970, 9973, 9981, 9986, 9989, 9992, 9993, 9995, 10062, 11088, 127746, 127749, 127796, 127797, 127800, 127802, 127803, 127805, 127806, 127807, 127809, 127812, 127813, 127815, 127827, 127925, 127931, 127984, 128018, 128024, 128054, 128105, 128107, 128115, 128116, 128118, 128123, 128124, 128152 ];                 
var arr = [8986, 8987, 9200, 9748, 9749, 9875, 9917, 9924, 9925, 9940, 
           9962, 9970, 9973, 9981, 9986, 9989, 9992, 9993, 9995, 10062,
           11088, 127746, 127749, 127796, 127797, 127800, 127802, 127803, 127805, 127806,
           127807, 127809, 127812, 127813, 127815, 127827, 127925, 127931, 127984, 128018, 
           128024, 128054, 128105, 128107, 128115, 128116, 128118, 128123, 128124, 128152 ];                     

var s_max= 49;    // maximum shape type [36 or 49 => arr.lenght-1]. Don't change this without changing dependent functions (see source code) 

var raster = [];   // 1. dim == item count (0..itemCnt-1). 2 dim = [0=row count, 1= column count]

var startTime;    //  used for asynchronously timer repaint. see wm12Timer() function - global time stamp

var delay= false;  // used for asynchronously timer repaint. see wm12Timer() function - global flag

var moves = [];    // number of moves in each level

var errors= [];		 // number of errors in each level

var print = 0;     // number of print screen key press

/* 
  https://www.helpfulgames.com/subjects/brain-training/memory.html
	https://www.memozor.com/memory-games/for-adults
	https://www.webgamesonline.com/memory/
  https://matchthememory.com/countries-of-europe
*/

//  xxxxxxxxxxxxxxx     wm12 functions  xxxxxxxxxxxxxxxx


// init html page [create/start Timer, check storage, show start panel..] 
function init() 
{  
  if (timer_id)  {   
    window.clearInterval(timer_id);  
  }  
  timer_id= setInterval(function () {wm12Timer()},clock);      
  if (isStorage() && storageAvailable('localStorage'))  {
    document.getElementById("store_group").disabled= false;
  }
  else  {
    document.getElementById("store_msg").textContent= "Your browser probably doesn't have support for the Web Storage Object or access to the Storage Object is disabled. Check your browser settings. In some browsers (IE11, Edge) Storage Object is not enabled when accessed in a local file (offline).";
    document.getElementById("store_group").disabled= true;  
    document.getElementById("clr_store").disabled= true;     // IE11 bug  => childrens are not auto disabled
    document.getElementById("store").disabled= true;          // IE11 bug => childrens are not auto disabled
  }          
	setIns();
	showStart();
  document.onkeyup = checkPS; 	// You can turn it off. This function is implemented because of possible cheating. 
}


// set instructions text
function setIns()  
{
  document.getElementById("instructions").style.display= "block";	
	document.getElementById("ins_back").style.display = is_back ? "block" : "none";
	document.getElementById("ins_forward").style.display = is_forward ? "block" : "none";
	document.getElementById("ins_demo").style.display= demo ? "block" : "none";	
	if (document.getElementById("timer_enabled").checked)  
	{
		document.getElementById("ins_timer").setAttribute("style", "display:block");
		document.getElementById("ins_timer").textContent= "The duration of this task is limited.";
		if (prg_type === "0")  {
	    document.getElementById("ins_timer").textContent+=" At the bottom of the screen will be information on how many pages are left until the end of the task.";
		}
		else if (prg_type === "1")  {
		  document.getElementById("ins_timer").textContent+= " The remaining time until the end of the task is shown to you at the bottom of the screen.";  
		}
		else  {
		  document.getElementById("ins_timer").textContent+= " But information about the remaining time will not be visible";  
		}  
  }
	else  
	{
		document.getElementById("ins_timer").setAttribute("style", "display:none");
	}	
}	


// show start panel 
function showStart()  
{      
  document.getElementById("end").style.display= "none";
  document.getElementById("google_wrapper").style.display="none";
  document.getElementById("table_grp").style.display="none";  
  document.getElementById("start").style.display= "block";
}


// before using web storage, check browser support for localStorage and sessionStorage
function isStorage()  {
  if (typeof(Storage) !== "undefined") {
     return true;               //  localStorage/sessionStorage is supported     
  } 
  else {
    return false;           // no browser Web Storage support
  }  
}


// necessarily because of IE11 and Edge offline mode
function storageAvailable(type) {
  try  {
    return (window[type]) ? true: false;   
  }
  catch(e) {
    return false;
  }
}


// deprecated but still works: https://developer.mozilla.org/en-US/docs/Web/API/KeyboardEvent/keyCode
// https://developer.mozilla.org/en-US/docs/Web/API/KeyboardEvent/code
// this function is implemented because of possible cheating during task. You can turn it off in function init() 
function checkPS(e)   { 
  e = e || window.e;  
  if (is_task && e.key === "PrintScreen") {      
    print++;
    return false;   
  } 
}


// show forms with application options (settings)
// <!-- IMPORTANT: showOption() and hideOption() buttons must be outside form element -->
function showOption()   
{
  document.getElementById("hide_option").style.display ="block";
  document.getElementById("options").style.display= "block";
  document.getElementById("start").classList.remove("child");  // don't work in <= IE 9    
  document.getElementById("start_div").style.display="none";  // .disabled = true;   
  document.getElementById("show_option").style.display ="none";  
  document.getElementById("hide_option").setAttribute("style","text-align:center");  // bug? auto-remove style when element.style.display="none"
  document.getElementById("instructions").style.display ="none";     
  if (document.getElementById("store_group").disabled === false && localStorage.getItem("wm12-v1.0")) 
  {
    var cnt= JSON.parse(localStorage.getItem("wm12-v1.0")).length;                                                        
    document.getElementById("store_cnt").textContent=  "You have a total of " + cnt  + " wm12 results stored in your web browser";
  }
  dirty= false;
}


// <!-- IMPORTANT: showOption() and hideOption() buttons must be outside form element -->
// save to window global vars all user Options/Settings
function hideOption()  
{
  setVarPar();   
  
	document.getElementById("options").style.display="none"; 
  document.getElementById("start").classList.add("child");   
  document.getElementById("show_option").style.display ="block";   
  document.getElementById("start_div").style.display="block";        //.removeAttribute("disabled");  
  document.getElementById("hide_option").style.display ="none";   
  document.getElementById("start_div").setAttribute("style","text-align:center");  // bug?  (firefox auto remove class "center" when set style.display.none;)
  document.getElementById("show_option").setAttribute("style","text-align:center");   // bug?

  setIns();  
      
  refMsg();  
}

       
// refresh variable research Options (update *_msg label) => give user short option HELP
function refOption(e)  
{   
  dirty=true;       
  var my_id = e.id, msg = document.getElementById(my_id + "_msg"), s = "Values within this range are allowed: ", s2= " with step= ", tmp;    
  
  switch (my_id)
  {
    
    case "lc":
		case "hc":
		  tmp= (document.getElementById("emoji").value === "1") ? "For Stimulus Type = Emoji the allowed range is 4..100 with a step of 4" : "For Stimulus Type = Shapes the allowed range is 4..72 with a step of 4";
			if (e.validity.valid)  {           
				msg.removeAttribute("class");       
				msg.textContent= "";       //msg.textContent=  e.value; 
			}
			else  {
				msg.textContent= tmp;
				msg.setAttribute("class", "error");    // msg.className = 'error';
			} 
      refItem();			
			break;
		
		case "wc":			
    if (e.validity.valid)  {           
      msg.removeAttribute("class");       
      msg.textContent= "";       
    }
    else  {
      msg.textContent= s + e.min + ".." + e.max + s2 + e.step;
      msg.setAttribute("class", "error");    
    } 			
		refItem();
		break;
		             
    case "emoji":     
      if (e.value === "1")  {  
        msg.innerHTML= "Emoji will be displayed. You should see elephant here: " + "&#128024";            
        document.getElementById("lc").max= 100;
				document.getElementById("hc").max= 100; 
      }             
      else  {            
        msg.textContent= "Geometric shapes will be displayed.";
        if (document.getElementById("lc").value > 72)  {
					document.getElementById("lc").value= 72;
				}
				if (document.getElementById("hc").value > 72)  {
					document.getElementById("hc").value= 72;
				}
				document.getElementById("lc").max= 72;  // 36 * 2
				document.getElementById("hc").max= 72; 	// 36 * 2							
      }
      break;
                     
    case "tcolor":                                                                                                                                            
      msg.textContent= (e.value === "0") ? "Drawings will be displayed only in basic html colors." : "The drawings will be displayed in all possible colors.";
      break;
     
    case "is_back":
      msg.textContent= e.checked ?  "Yes" : "No";         
      break;
    
		case "is_forward": 
      msg.textContent= e.checked ? "Yes. Warning: if the participant does not complete the task (there are missing values), the full statistics will not be displayed" : "No";         
      break;
				
    case "demo":    
      if (e.checked)  {
        msg.textContent= " Yes - When the user selects the first cell: the correct choice will be presented with the X sign. Like this: ";
        document.getElementById("demo_x").setAttribute("style", "display:inline;background-color:#000000;color:#ffffff;font-weight:bold"); 
      }
      else  {
        msg.textContent= " No";
        document.getElementById("demo_x").setAttribute("style", "display:none"); 
      }    
      break; 
		
    case "timer":
      if (e.validity.valid)  {
        msg.textContent= stringTime(e.value); 
        msg.removeAttribute("class");
      }
      else  {
        msg.textContent= s + e.min + ".." + e.max + s2 + e.step;
        msg.setAttribute("class", "error");
      } 
      break;                
      
    case "timer_enabled":   
      if (e.checked)  {
        msg.textContent= "Yes";
        document.getElementById("timer").disabled= false;
      }
      else  {  
        msg.textContent= "Timer is disabled";
        document.getElementById("timer").disabled= true; 
      }       
      break;
       
    case "prg_type":                                                                                                                                            
      if (e.value === "0")  {
        msg.textContent= "It will be displayed how many items are left to the end.";
      }
      else if (e.value === "1")  {
        msg.textContent= "The remaining time until the end of the task will be displayed.";
      }
      else  {
        msg.textContent= ""; //"Nothing";
      }
      break;    
      
    case "store":                                                                                                                                            
      msg.textContent= (e.value === "1") ? "This web application will store the results inside your web browser (no expiration date). Useful for group research" : "This web application will not store results within your web browser. Data is lost when the browser tab is closed";
      break;  
      
  }   // switch (my_id)
       
}


// update item count on options form and check lc <= hc and update label item_cnt
function refItem()  
{
   var _lc = document.getElementById("lc");
   var _hc = document.getElementById("hc");
   var _wc= document.getElementById("wc");
   var _item= document.getElementById("item_cnt");
   var lc_msg= document.getElementById("lc_msg");
   var hc_msg= document.getElementById("hc_msg");    
   if (_lc.validity.valid && _hc.validity.valid && _wc.validity.valid)   
   {                      
     if  (parseInt(_lc.value,10) > parseInt(_hc.value,10))  
     {
       lc_msg.textContent= "The starting level must not be higher than the final level";  
       hc_msg.textContent= "The starting level must not be higher than the final level";
       lc_msg.setAttribute("class", "error");
       hc_msg.setAttribute("class", "error");    
       _item.textContent= "Total number of items: Invalid value"; 
       _item.setAttribute("class", "error");
     } 
     else   {                                                                                               
       lc_msg.removeAttribute("class");    //lc_msg.textContent= _lc.value;
       hc_msg.removeAttribute("class");   //hc_msg.textContent= _hc.value; 
       var tmp= ( parseInt(_hc.value,10) - parseInt(_lc.value,10) ) / 4 + 1;
			 _item.textContent=  "Total number of items: " + parseInt(_wc.value,10) * tmp;       
       _item.removeAttribute("class");
     }
   } 
   else  
   {
     _item.textContent= "Total number of items: Invalid value"; 
     _item.setAttribute("class", "error");
   }    
}


// refresh main validator message for user defined OPTIONS (feedback to user)
function refMsg()   
{ 	
	if ( optionsValid() )  {
    document.getElementById("is_valid").textContent=  (dirty===true) ? "All your settings have been successfully updated" : "";  
    document.getElementById("is_valid").setAttribute("style", "text-align:center;color:#000000"); 
  }
  else  {
    document.getElementById("is_valid").textContent="Some of your options are incorrectly set. They were not updated. These settings are marked in red."; 
    document.getElementById("is_valid").setAttribute("style", "text-align:center;color:#ff0000;font-weight:bold"); 
  } 	
}


// check for validity.valid object in all input type="number" and lc <= hc
function optionsValid()  
{     
  var res=  document.getElementById("lc").validity.valid && 
    document.getElementById("hc").validity.valid &&
    (parseInt(document.getElementById("lc").value,10) <= parseInt(document.getElementById("hc").value,10))  &&   
    document.getElementById("wc").validity.valid  &&  
    document.getElementById("timer").validity.valid;       
  return res;                   
}


// start task 
function startTask(e)   
{       
  e.disabled= true;
  stimGenerator(); 
  e.disabled= false;   
  do  
    var ok= e.disabled;
  while (ok); // timer will wait for stimulus generator for large itemCnt 
  document.getElementById("google_wrapper").style.display="none";
  document.getElementById("end").style.display= "none"; 
  document.getElementById("start").style.display= "none"; 
  document.getElementById("canvas").style.display="block";                 
  //timer_enabled= (document.getElementById("timer_enabled").checked) ? true: false;  // timer is enabled or disabled
  document.getElementById("canvas").setAttribute("title", "Click on two tiles to find two matching images");
	document.getElementById("canvas").style.cursor= "auto";
	document.getElementById("time_left").textContent= "";
	if (document.getElementById("prg_type").value === "2") {
	  document.getElementById("progress").style.display= "none"; 
	}	
	else  
	{
		document.getElementById("progress").style.display= "block";     
		document.getElementById("progress").setAttribute("style", "width:100%");   		
		if (document.getElementById("prg_type").value === "0") {
		  document.getElementById("progress").className="progress-bar progress-bar-info progress-bar-striped";     // items/total
		}
		else if (document.getElementById("prg_type").value === "1")  {
		  document.getElementById("progress").className= "progress-bar progress-bar-danger progress-bar-striped";  // remaining time   
		} 	
		document.getElementById("progress").setAttribute("style", "width:0");  // reset progress bar width
	}
	
	delay= false;     // turn off asynchronously repaint
  counter= 0;       // reset timer counter
  is_task= true;    // finally "activate" timer  	
  item=0;
  drawStim(false);     // draw first stimulus     
}


// set application variable parameters
function setVarPar()  
{   
 
  if (document.getElementById("lc").validity.valid && document.getElementById("hc").validity.valid 
    && (parseInt(document.getElementById("lc").value,10) <= parseInt(document.getElementById("hc").value, 10) ) )   {  
      lc= parseInt(document.getElementById("lc").value, 10); 
      hc= parseInt(document.getElementById("hc").value, 10); 
  }
  
  if (document.getElementById("wc").validity.valid) wc= parseInt(document.getElementById("wc").value, 10);  
		                  
  emoji = (document.getElementById("emoji").value === "1") ? true : false ;  // stimulus type ("1" => Emoji or "0" => Geometric Shapes) 
                   
  tcolor= (document.getElementById("tcolor").value === "0") ? false: true;  // false => only use basic html colors; true => use full random colors palette     
  
  is_back= (document.getElementById("is_back").checked) ? true: false;   // enable Go back (previous item)      
  
  is_forward= (document.getElementById("is_forward").checked) ? true: false; // enable forward (skip item)
	
	demo= (document.getElementById("demo").checked) ? true: false; // demo mode = true => show correct choice
	
  if (document.getElementById("timer").validity.valid) timer= Math.round(parseInt(document.getElementById("timer").value, 10));  // task time (s)
  
	timer_enabled= (document.getElementById("timer_enabled").checked) ? true: false;  // timer is enabled or disabled
	
  prg_type= document.getElementById("prg_type").value;   //  type of information displayed on Progress Bar   
   
  store= ( document.getElementById("store_group").disabled === false && document.getElementById("store").value === "1") ? true : false;
  
  s_max= emoji ? (arr.length-1) : 36; 
  
}


// set internal application research parameters
function setPar()  
{  
  // this section is probably redundant protections for infinitive loops. you can turn it off
	if (!emoji && lc > 72)  {
		lc=4;
		document.getElementById("lc").value= 4;
	}
	if (!emoji && hc > 72)  {
		hc=72;
		document.getElementById("hc").value= 72;
	}
	if (lc > 100)  {
		lc=4;
		document.getElementById("lc").value= 4;
	}
	if (hc > 100)  {
		hc=100;
		document.getElementById("hc").value= 100;
	}
		
  itemCnt= 0;
	errors= [];
	moves= [];
  for (var i=lc; i<=hc; i+=4) 
	{
		moves[i]= 0;
    errors[i]= 0;
		for (var j=1; j<=wc; j++) {
			itemCnt++;			
		}		
	}		
  stim_b= [];  // bounds for stimulus
  stim= [];    // [item][shape] 
  
	raster= [];
	print= 0;	
}


// main stimulus generator function
function stimGenerator()  
{ 	
	setPar();      
  setPage();      
  for (var i=0; i<itemCnt; i++)  {  // ordinal item count [0..itemCnt-1] 
    stim[i]= [];   
    stim[i]= setStim(i);               
  }           
}


/* set canvas (viewport) choices (options) bounds        
   stim_b array =>  [0] = left; [1] = top; [2] = right; [3]= bottom  */                                                                                    
function setPage()  
{ 
  // set canvas position
	document.getElementById("footer").style.display="block";  
  document.getElementById("footer").height= "50";  // const. see img: backward.png => height and forward.png.height  
  var canvas= document.getElementById("canvas");    
	canvas.left= 0; 
  canvas.top= 0;
  canvas.width= window.innerWidth;       // stretch canvas to parent
  canvas.height= window.innerHeight - document.getElementById("footer").height;                                     	
	// set window.rad array => shape radius in function of item level  
	var level=lc, j= 0, rows, cols, dx, dy,  off_x, off_y, _left, _top, _right, _bottom;  
	for (var i=0; i<itemCnt; i++)
  {  		    
		raster[i]= setRaster(level);
		rows= raster[i][0];
    cols= raster[i][1];		
		dx= Math.floor(0.8 * canvas.width/cols);  // margin: 10% up + 10% down
		dy= Math.floor(0.8 * canvas.height/rows); // margin: 10% left + 10% right
		rad[i]= Math.floor(Math.min(dx,dy)/2);  // this is shape radius. shape == drawings  				 		
		off_x= Math.floor( (canvas.width  - cols * 2*rad[i]) / 2 );   // remainder space x => offset x
		off_y= Math.floor( (canvas.height - rows * 2*rad[i]) / 2 );   // remainder space y => offset y  
		_left= off_x;   
		_top= off_y;
		_right= canvas.width - off_x;
		_bottom= canvas.height - off_y; 
		stim_b[i]= [_left, _top, _right, _bottom];  //  for each item =>  [0] = left; [1] = top; [2] = right; [3]= bottom 	
		j++;
		if (j === wc)  {
			j=0;
			level+=4;
		}	    
	}	
}


/* return number of rows and columns for each item. set grid item raster.
   cnt == total number of shapes in this item
   return res[0]= number of rows in grid, res[1]= number of columns in grid for this item */
function setRaster(cnt)  
{	
	/*
	  4 = 2 x 2;
		8 = 4 x 2 or 2 x 4;
	 12 = 4 * 3 or 3 x 4;
	 16 = 4 x 4
	 20 = 5 x 4 or 4 x 5
	 24 = 6 x 4 or 4 x 6
	 28 = 7 x 4 or 4 * 7
	 32 = 8 x 4 or 4 x 8
	 36 = 6 x 6
	 40 = 8 x 5 or 5 x 8
	 44 = 11 x 4 or 4 x 11
	 48 = 8 * 6 or 6 x 8
	 52 = 13 * 4 or 4 x 13
	 56 = 8 x 7 or 7 * 8
	 60 = 10 * 6 or 6 x 10
	 64 = 8 x 8
	 68 = 17 x 4 or 4 x 17
	 72 = 9 x 8 or 8 x 9
	 76 =  19 x 4 or 4 x 19
	 80 =  10 x 8 or 8 x 10
	 84 =  12 x 7 or 7 x 12
	 88 =  11 x 8 or 8 x 11
	 92 =  23 x 4 or 4 x 23
	 96 =  12 x 8 or 8 x 12
	 100 = 10 x 10 
	 */
	var r, c, tmp;	// grid rows and columns count are hardcoded to fixed values. you can change it here (bellow).
	switch (cnt)
	{
		case 4:
			c= 2;
			break;
		case 8:
		case 12:
		case 16:
			c= 4;
			break;
		case 20:
			c= 5;
			break;
		case 24:
			c= 6;
			break;		
		case 28:
			c= 7;
			break;
		case 32:
			c= 8;
			break;		
		case 36:
			c= 6;
			break;
		case 40:
			c= 8;
			break;
		case 44:
			c= 11;
			break;
		case 48:
			c= 8;
			break;
		case 52:
			c= 13;
			break;
		case 56:
			c= 8;
			break;	
		case 60:
			c= 10;
			break;
    case 64:
			c= 8;
			break;	 
		case 68:
			c= 17;
			break;
    case 72:
			c= 9;   
			break;			
		case 76:
      c= 19; 
      break;			
		case 80:
      c= 10; 
      break;				
		case 84:
      c= 12;   
      break;			
		case 88:
      c= 11;  
      break;					
    case 92:
      c= 23;   
      break;	
    case 96:
      c= 12;  
      break;						
		case 100:
      c= 10;   
      break;				
    /*default:
      alert('Error: Each level must be divisible by 4 without remainder and in range 4..100 or 4..72. Task not created.');*/		
	}			 
	r= cnt/c; 
	if (canvas.width < canvas.height)  {
		tmp= r;
		r= c;
		c= tmp;
	}		
	var res= [r,c];  // row count and column count	
	return res;
}


/* set stimulus coordinates; generate stim-coord (x,y) and default properties (color, shapes type)
   parameter:  itm = item in range [0..itemCnt-1] 
   return res = stim coordinates = jagged array= [shape] x [ [0]= x; [1]= y;  [2]= shape type; [3]= color; [4]= selected or not selected; [5]= cell is done (closed) or not done (open) ] */     
function setStim(itm) 
{    	
	var rows, cols, half, rnd, sel= {}, shp=[], col=[], x, y= stim_b[itm][1], k=0, res= []; // res= function result  
  rows= raster[itm][0];  // row count in this item
	cols= raster[itm][1];  // column count in this item
	half= rows*cols/2;
	for (var i=1; i<=half; i++)
  { // first half of shapes: choose random shape type and color
		do  {
      rnd= getRndInt(0, s_max);    // get new random shape type
    }  while (typeof sel[rnd] != "undefined");
    sel[rnd]= rnd;  // exclude this shape type from next iterations
		shp.push(rnd);
		rnd= tcolor ? getRndColor() : getColor();     // any random color
    col.push(rnd);    
  } 
  sel={};
	for (var i=1; i<=half; i++)
  { // second half of shapes: choose random positions from first half and just copy shape type and color
		do  {
      rnd= getRndInt(0, half-1);    // get new random position from first half (this is array index of shp and col arrays)
    } while (typeof sel[rnd] != "undefined");
    sel[rnd]= rnd; // exclude this from next iterations 
		shp.push(shp[rnd]);  // copy shape type from first half
		col.push(col[rnd]);  // copy color from first half 		
  } 
  // finally create result array with x, y positions, shape type, colors,...
	for (var i=1; i<=rows; i++) 
  { // i == screen row == x     
    x= stim_b[itm][0];   // stim_b array =>  [0] = _left;
    for (var j=1; j<=cols; j++)  
    {  // j == screen column == y                                          
      res.push([x, y, shp[k], col[k], false, false]);  // [0]=x; [1]=y; [2]=shape type; [3]=color; [4]=selected or not selected; [5]=cell is done (closed) or not done (open); 
			k++;
      x+=2*window.rad[itm];  // new shape within row => add x
    } 
    y+=2*window.rad[itm];  // new row (add y)
  }  
	return res;  
}


// sets one of mostly basic html predefined colors
// this is mostly default set of 16 html Basic colors 
function getColor() 
{
  var clr = [    
    '#000000',     /* "black" */   
    '#FF0000',     /* "red"   */
    '#008000',     /* "green" */
    '#0000FF',     /* "blue" */   
    '#FFFF00',     /* "yellow" */     
    '#00FF00',     /* "lime" */     
    '#00FFFF',     /* "cyan" / "aqua" */     
    '#FF00FF',     /* magenta / fuchsia  */  
    '#C0C0C0',     /* "silver" */      
    '#800000',     /* maroon */     
    '#808000',     /* "olive" */  
    '#800080',     /* "purple" */    
    '#008080',     /* teal */      
    '#000080',     /* navy */    
    '#FFC0CB',     /* "pink" */           
    '#FFA500'      /* "orange" */ 
    ];      
  var rnd= Math.floor(Math.random()*16);   // returns a random integer from 0 to 15 
  //var rnd= getRndInt(0,15);  // array clr limits
	return clr[rnd];
}


// get full random colors in hex format
function getRndColor() {
  var letters = '0123456789abcdef';
  var color = '#';
  for (var i=0; i<6; i++) {
    color += letters[Math.floor(Math.random() * 16)];     // returns a random integer from 0 to 15 
  }
  return color;
}  


// get random integer from min to max range
function getRndInt(min, max) {
  return Math.floor(Math.random() * (max - min + 1)) + min;
}


// application timer handler function
function wm12Timer()  
{ 
  if (!is_task) {
		return;  // nop, idle, do nothing        
  }	       
	if (timer_enabled) 
	{
		counter++;
		if (counter >= timer)  {     // task time is limited
			theEnd();
			return;
		}	
		if (prg_type === "1")   {   // "1" => Time. display time on Progress Bar  
			var rest=timer-counter;   // this is remaining time 
			var percent= Math.round(100*rest/timer);    
			document.getElementById("progress").setAttribute("style", "width:"+percent+"%");    // !important
			document.getElementById("time_left").textContent= stringTime(rest);    
		}
	}		
	if (delay)  
	{
		var endTime= new Date(); 		
    if ( (endTime.getTime() - startTime.getTime())/1000 > 1)  
		{
			delay= false;  // do repaint only once
			document.getElementById("canvas").setAttribute("title", "Click on two tiles to find two matching images");
			document.getElementById("canvas").style.cursor= "auto";
			reset();  // repaint with cca 1s delay 	
			if (itemDone())  {
				nextItem();  
				//return;
			}
			else  {
				drawStim(false);  // repaint with cca 1s delay 	
			}		
		}			
	}		
} 


// set all shapes in current item as not selected 
function reset()  
{
	for (var s in stim[item])  {   // s = shapes within item                                        
		stim[item][s][4]= false;  
	}              		
}	


// return integer into string hh:mm:ss time format
// input par: total == integer (time in seconds)
function stringTime(total) 
{
  var hh = Math.floor(total/(60*60));         
  var divisor_for_minutes = total % (60 * 60);
  var mm = Math.floor(divisor_for_minutes / 60);       
  var divisor_for_seconds = divisor_for_minutes % 60;
  var ss = Math.ceil(divisor_for_seconds);    
  // These lines ensure you always have two-digits. This formats your string to HH:MM:SS
  if (hh < 10)  {hh = "0"+hh;}     
  if (mm < 10) {mm = "0"+mm;}
  if (ss < 10) {ss = "0"+ss;} 
  return hh + ":" + mm + ":" + ss;
} 


// goto previous item (stimulus)
function priorItem()  
{                         
  if (item > 0)  {
    item--;  
    drawStim(false);     // draw again previous stimulus
  }         
}


// goto next item (stimulus)
function nextItem()  
{               
  if (item < itemCnt-1)  {         
    item++; 
    drawStim(false);     // draw next stimulus        
  }
  else  {               
    theEnd();  // end of task  
  }
}


// return true if current item is done; else return false 
function itemDone()
{
	for (var s in stim[item])  {
		if (!stim[item][s][5]) {
			return false; 
		}		
	} 	
	return true;	
}


// draw (repaint) stimulus 
// if (is_delay == true) => draw grey color outer border around stim_b[item] section => feedback to user to wait for timer action => all this item shapes are not responsive to click
// if (is_delay == false) => there is no outer border around stimulus => this is feedback to user that stimulus is responsive  
function drawStim(is_delay) 
{    
  var canvas= document.getElementById('canvas');
  var ctx= canvas.getContext('2d'); 
	ctx.clearRect(0, 0, canvas.width, canvas.height);      // clear canvas                                
    
	if (is_delay)  {
		ctx.fillStyle= '#e5e5e5';  // feedback to user to wait
		ctx.rect(0, 0, canvas.width, canvas.height);  // inner canvas section (stim_b[item]) will be repainted latter with white color
		ctx.fill();     	
	}
	
	// this section draw border around stim_b[item] array
	ctx.strokeStyle= "#000000";
  ctx.beginPath(); 
	// [0] = left; [1] = top; [2] = right; [3]= bottom
  // width= right-left = [2]-[0]; height= bottom-top = [3]-[1]; 
	ctx.rect( stim_b[item][0]-5,  stim_b[item][1]-5, stim_b[item][2] - stim_b[item][0] + 10 ,  stim_b[item][3] - stim_b[item][1] +10 );   // draw border around stim_b[item] array  
  ctx.stroke(); 			
 
	var ind=null, is_done=true;
	var show = (demo && getSelCount() === 1) ? true: false; 
	 	
	for (var s in stim[item])   
  {   // s= shapes within item                                              
    ctx.beginPath();  
    ctx.rect(stim[item][s][0], stim[item][s][1], 2*rad[item], 2*rad[item]);   //  	context.rect(x,y,width,height);   
    ctx.fillStyle= (stim[item][s][5] || stim[item][s][4]) ? '#ffffff' : '#000000';  // background color for all closed (done) cells is: white. background color for all not done cells is: black color      
		ctx.fill(); 		
		ctx.lineWidth=5;
	  ctx.strokeStyle= '#ffffff';  // white border around each cell                             		           		
    ctx.stroke();  // draw white border around all cells 
		if (stim[item][s][4])  
		{    // show selected cells     
			if (emoji)  {
				drawEmoji(ctx, stim[item][s][0], stim[item][s][1], stim[item][s][2], stim[item][s][3]);   
			}
			else  {
				drawShape(ctx, stim[item][s][0], stim[item][s][1], stim[item][s][2], stim[item][s][3]);   
			} 
      ind= s;			
		}
		if (!stim[item][s][5]) {
			is_done=false;  
		}	
  }  

	if (show && ind != null) 
	{  // show correct match pair. draw X in this cell
		for (var j in stim[item])  
		{   // j = cells (shapes) within item                                        
			if ( j != ind && stim[item][j][4] === false && stim[item][j][2] === stim[item][ind][2] && stim[item][j][3] === stim[item][ind][3] )  
			{ 
				ctx.moveTo(stim[item][j][0], stim[item][j][1]);
				ctx.lineTo(stim[item][j][0]+2*rad[item], stim[item][j][1]+2*rad[item]);
				ctx.moveTo(stim[item][j][0]+2*rad[item], stim[item][j][1]);
				ctx.lineTo(stim[item][j][0], stim[item][j][1]+2*rad[item]);
				ctx.strokeStyle= '#ffffff';
				ctx.lineWidth=5;
				ctx.stroke();		 
			}	
		}  							
	}	
	
	if (is_done && !is_delay)
	{ 		
		ctx.clearRect(0, 0, canvas.width, canvas.height);      // clear canvas
		var x= stim_b[item][0] + (stim_b[item][2] - stim_b[item][0])/2;	 // left + (right-left)/2  stim_b: [0] = left; [1] = top; [2] = right; [3]= bottom
		var y= stim_b[item][1] + (stim_b[item][3] - stim_b[item][1])/2;	// top + (bottom-top)/2	    
		ctx.textAlign = "center";
		ctx.textBaseline = "middle";
		ctx.font = "5em Georgia";  
		ctx.fillStyle = "#000000";  // line color 
		ctx.fillText("This task is done", x, y);                               
	}  
	  
  // set footer navigation prior button (left arrow) 
  if (item > 0 && is_back)  {  
    document.getElementById("prior").style.display= "inline"; 
  }
  else  {
    document.getElementById("prior").style.display= "none";   
  }   
	// set footer next item button (right arrow)
  if (is_forward)       
  {  
    var btn= document.getElementById("next");     
    btn.style.backgroundImage= (item === itemCnt-1)  ?  "url('img/end.png')" : "url('img/forward.png')";  // update "Next item" image on "right arrow" button 
    btn.style.display= "inline";  
  }
  else {
    document.getElementById("next").style.display= "none";
  }				
	// display (update) item count on Progress Bar (default)  
  if (prg_type === "0" )  {                                                                                                                                                         
    var percent = 100*(itemCnt-(item+1))/itemCnt;  // Math.round();      
    document.getElementById("progress").setAttribute("style", "width:"+percent+"%");    // !important
    document.getElementById("time_left").textContent= "Item= " + (item + 1) + " Remaining= " + (itemCnt - item-1);  
  } 
}


/* draw all emoji
   ctx = canvas context
   x = x coord square center,
   y = y coord square center   
   shape = e-moji type  
   col = color (fillSyle and/or strokeStyle) */
function drawEmoji(ctx, x, y, shape, col)
{             
	x+=rad[item];    
  y+=2*rad[item]; 		                                                                   
  // https://developer.mozilla.org/en-US/docs/Web/CSS/font-family   https://www.w3schools.com/cssref/css_websafe_fonts.asp
  ctx.font = Math.round(1.5*rad[item]).toString() + "px monospace, Courier";    
  ctx.textBaseline="bottom";       ctx.textAlign = "center";  
  // Firefox, Chrome, Edge, Opera: ignore ctx.fillStyle and  ctx.strokeStyle= col  
  ctx.fillStyle = col;   // fill color => this line must be (only necessary for: IE11, Safari) 
  ctx.strokeStyle= col;  // line color (outer border line color). (only necessary for: IE11, Safari)            
  // why using: "tmp" element? because  Backward compatibility.  why not:  String.fromCodePoint()  ?  see: https://caniuse.com/#search=fromCodePoint
  //ctx.fillText(String.fromCodePoint(arr[shape]), x, y);     // direct decimal to emoji. => don't work in IE11, Opera Mini,..
  document.getElementById("tmp").innerHTML="&#" + arr[shape]; 
  ctx.fillText(document.getElementById("tmp").innerHTML, x, y);     // end of draw point number within each Circle       
  //ctx.strokeStyle= "#000000";  // restore to black  
}


/* shape function dispatcher (handler)
   ctx = canvas context
   x = x coord square center,
   y = y coord square center   
   shape = shape type => this argument is main for call different shapes.js functions  
   col = color (fillSyle and/or strokeStyle)
   shapes.js file must be included in DOM  (wm12.html)
*/ 
function drawShape(ctx, x, y, shape, col)
{ 
  x+=rad[item];    
  y+=rad[item];
	var r=Math.round(0.90*rad[item]);    // leave 10% blank space within rect	
	
  ctx.fillStyle = col;   // fill color
  ctx.strokeStyle= col;  // line color   
  switch (shape)  
  {
    case 0:   // full circle
    case 1:   // 1/2 circle RIGHT oriented
    case 2:   // 1/2 circle DOWN oriented   
    case 3:   // 1/2 circle LEFT oriented
    case 4:   // 1/2 circle UP oriented 
    case 5:   // 3/4 circle with UP-RIGHT hole
    case 6:   // 3/4 circle with DOWN-RIGHT hole
    case 7:   // 3/4 circle with DOWN-LEFT hole 
    case 8:   // 3/4 circle with UP-LEFT hole                          
     if (shape === 0)  {                        
       circle(ctx, x, y, r, 0, 2*Math.PI, false, col);  // full circle 
     }        
     else if (shape === 1)  {
       circle(ctx, x, y, r, 1.5*Math.PI, 0.5*Math.PI, false, col); // 1/2 circle RIGHT oriented      
     }
     else if (shape === 2)  {
       circle(ctx, x, y, r, 0, Math.PI, false, col); // 1/2 circle DOWN oriented     
     } 
     else if (shape === 3)  {
       circle(ctx, x, y, r, 0.5*Math.PI, 1.5*Math.PI, false, col); // 1/2 circle LEFT oriented     
     } 
     else if (shape === 4)  {
       circle(ctx, x, y, r, Math.PI, 0, false, col);   // 1/2 circle UP oriented     
     }        
     else if (shape === 5)  {
       circle(ctx, x, y, r, 0, 1.5*Math.PI, false, col);   // 3/4 circle with UP-RIGHT hole     
     } 
     else if (shape === 6)  { 
       circle(ctx, x, y, r, 0, 0.5*Math.PI, true, col);   // 3/4 circle with DOWN-RIGHT hole     
     } 
     else if (shape === 7)  { 
       circle(ctx, x, y, r, 0.5*Math.PI, Math.PI, true, col);   // 3/4 circle with DOWN-LEFT hole     
     } 
     else if (shape === 8)  { 
       circle(ctx, x, y, r, 1.5*Math.PI, Math.PI, false, col);   // 3/4 circle with UP-LEFT hole     
     }        
     break;
                
    case 9:   // polygon 3 equal sides
    case 10:  // polygon 4 equal sides   
     (shape === 9) ? polygon(ctx, x, y, r, 3, col):  polygon(ctx, x, y, r, 4, col);       
     break;    
                  
    case 11:  //  xxxxxx
     square(ctx, x, y, r-2, col);  // only for square: window.r must be > 2 for shape selection and demo background fill style  
     break;  //   xxxxxx
             
    case 12:    // longer side (base) down
    case 13:    // longer side (base) up
     (shape === 12) ? trapezoid(ctx, x, y, r, col, true) : trapezoid(ctx, x, y, r, col, false) ;  // base down or up   
     break;
              
    case 14: // rectangle - horizontal line is longer then vertical
    case 15: // rectangle - vertical line is longer then horizontal 
     (shape === 14) ? rectangle(ctx, x, y, r, col, true): rectangle(ctx, x, y, r, col, false);              
     break;
                   
    case 16:
    case 17:
     if (shape === 16) {   // vertical ellipse
      var w= r, h= 2*r; // change this 2 param for PI/2 rotation
     }
     else {   // horizontal ellipse
      var w= 2*r, h= r; // change this 2 param for PI/2 rotation
     }
     ellipse(ctx, x - w / 2.0, y - h / 2.0, w, h, col);       
     break; 
                
    case 18: // cross => classic vertical cross
    case 19: // cross => diagonal cross (x) 
     (shape === 18) ? cross(ctx, x, y, r, col, true): cross(ctx, x, y, r, col, false);       
     break;   
             
    case 20:  //(base == true) => draw down-right rotated paralelogram; 
    case 21: // (base== false) => draw left-down rotated paralelogram
     (shape === 20) ? paralelogram(ctx, x, y, r, col, true): paralelogram(ctx, x, y, r, col, false);    
     break;
                               
    case 22:   // star 4-points
    case 23:   // star 5-points
    case 24:   // star 6-points     
     star(ctx, x, y, shape-18, r/2, r, col);       
     break;
                            
    case 25:  //  vertical UP arrow (0)
    case 26:  //  vertical DOWN arrow (1)
    case 27:  //  horizontal LEFT arrow (2)
    case 28:  //  horizontal RIGHT arrow (3)
     arrow(ctx, x, y, r, col, shape-25);       
     break;
            
    case 29:  
    case 30:
     var a= (shape === 29) ? [r, r, 0, 0] : [0, 0, r, r];    // up rect round radius (31) or down round rect radius (32)
     roundRect(ctx, x-r, y-r, 2*r, 2*r, a, col);    
    break;
       
    case 31:     //  mushroom UP oriented     
    case 32:     //  mushroom RIGHT oriented
    case 33:     //  mushroom DOWN oriented
    case 34:     //  mushroom LEFT orinted 
      mushroom(ctx, x, y, r, col, shape-31);
      break;
               
    case 35:  // polygon 5 equal sides
    case 36:  // polygon 6 equal sides      
      (shape === 35) ?  polygon(ctx, x, y, r, 5, col):  polygon(ctx, x, y, r, 6, col);       
      //break; 
                      
  }   // switch (shape) of
   
}  


// user selected shape (emoji) on screen canvas 
//<canvas id="canvas" onclick="doAnswer(event)"></canvas>   
function doAnswer(e)  
{        
  if (delay || !is_task) { 
		return;  // complete ignore user click (waiting for a timer to do asynchronously stimulus repaint)
	}
	var x= e.clientX, y= e.clientY;
  // stim_b =>  [0] = left; [1] = top; [2] = right; [3]= bottom 
  if (x > stim_b[item][0] && x < stim_b[item][2] && y > stim_b[item][1] && y < stim_b[item][3])  
  {      
    var rows= raster[item][0];
    var cols= raster[item][1];	
		var row= Math.ceil((y - stim_b[item][1])/(2*rad[item])) -1;    // always is >= 0
    var col= Math.ceil((x - stim_b[item][0])/(2*rad[item]))- 1;    // always is >= 0
    if (row <= rows && col < cols)  
    {   
      var p = row * cols + col; // shape position within stim[item] array (page)              
      if (stim[item][p])
      {  //[0] = x; [1] =y;  [2]= shape type; [3] = color; [4] = selected or not selected; [5] = cell is done (closed) or not done (open);         
				var sel= getSelCount();  
				if (stim[item][p][4] || stim[item][p][5] || sel > 1) {  // user can not deselect open (selected) cell or select done (closed) cell					
					return;  
				}
				if (stim[item][p][4] === false) { 
					stim[item][p][4]=true;  // select this choice 
					sel++;  								        
				}													
				if (sel === 2)	
				{ 
			    startTime= new Date();  // timer will repaint this item with delay 
					document.getElementById("canvas").setAttribute("title", "Wait..");
					document.getElementById("canvas").style.cursor= "wait";
					moves[stim[item].length]++;
					if (!areEqual(p))  {										
						errors[stim[item].length]++;					              
					}						
					delay= true; 	// asynchronously repaint (with time delay)	          					
        }        							
				drawStim(delay); // you must repaint stimulus (shape can be now selected or not selected, draw delay outer border or not draw outer border)
				/*if (sel === 2) {
				 drawStim(true);  	
				}
				else {
				 drawStim(false);
				}*/
																	
      }         
    }     
  }	
}


// get number of selected shapes in current item
function getSelCount()  
{
	var cnt= 0;
	for (var s in stim[item])  {   // s = shapes within item                                        
		if (!stim[item][s][5] && stim[item][s][4])  { // not done and selected cells (shapes)
			cnt++;    
		}	
	}              	
  return cnt; 	
}	


// checks if 2 currently selected drawings are equal (in shape and color).
// return true if they are equal
function areEqual(p)  
{	// [0] = x; [1] =y;  [2]= shape type; [3] = color; [4] = selected or not selected; [5] = cell is done (closed) or not done (open); 
  if (getSelCount() === 2)
	{
		for (var s in stim[item])  
		{   // s = shapes within item => must check if s is visible (selected): stim[item][s][4] == true                                        
			if ( s != p && stim[item][s][4] === true && stim[item][s][2] === stim[item][p][2] && stim[item][s][3] === stim[item][p][3] )  
			{ 
				stim[item][s][5]= true;   // first shape is done (closed) 
				stim[item][p][5]= true;   // second shape is done (closed) 
				return true;     
			}	
		}  
	} 	
	return false;	
}	


// end of task (research)
function theEnd()  
{   
  is_task= false;  
  
  document.getElementById("canvas").style.display="none"; // this disable doAnswer() event
  document.getElementById("footer").style.display="none";
  document.getElementById("end").style.display="block";  
  /* cor= number of correct matches, err= number of errors, mis= missing values, tot= maximum possible score, 
		 mov = number of moves, min_mov= minimum number of moves, eff = efficiency percentage  */
	var cor=0, err=0, mis=0, tot=0, mov= 0, min_mov=0, eff=null, e;  

  for (var i in stim)   
  {  // i == item
		min_mov+= stim[i].length/2;  // minimum possible number of moves on this item (level)  
		for (var s in stim[i])   
    {  // s => shape => [0]= x; [1]= y;  [2]= shape type; [3]= color; [4]= selected or not selected; [5]= cell is done (closed) or not done (open); 
	    tot++;
      if (stim[i][s][5]) { 
        cor++;   // done (closed)       
      }
      else  {
        mis++;       // not-done (open)
      }      
    }
  } 
  mis= mis/2;  // compute pairs
	cor= cor/2;
	tot= tot/2;
	for (var i in errors)   { 
	  err+= errors[i];  
	} 	
	e= document.getElementById('print_w');
	if (print > 0)  {
		e.setAttribute('style', 'display:block;text-align:center');
		e.textContent= 'Warning: the Print Screen key was pressed ' + print + ' times during the task';
	}	
	else  {
		e.setAttribute('style', 'display:none');
	}			
	
	document.getElementById("no_google").textContent="";  
	if (mis > 0)  
	{  // Number of correct matches
	  document.getElementById("score").textContent= "Total number of correct pairs= " + cor + " Total errors= " + err + " Maximum possible score=" + tot + " Missing= " + mis + ". Warning: You must complete the task to display all statistics, graphs and tables. Missing must be 0.";
	  try  {			
			drawMissingReport(cor, err, mis);  			
		}        
		catch (e)  { 
		  document.getElementById("no_google").textContent= "You must have an available internet connection to display graphs and tables. Make sure you are online."; 	
		} 	
	}
  else
	{  	 
		for (var i in moves)  { 
			mov+= moves[i];  
		} 		 				
		eff= 100*min_mov/mov; // eff = efficiency percentage		
		document.getElementById("score").textContent= "Moves= " + mov + ". Minimum number of moves to solve the task= " + min_mov + ". Efficiency percentage= " + eff.toFixed(2) + "%. Total errors= " + err;
	
		try  {
			drawReport(mov, min_mov, eff, err);  
		}
		catch (e)  {
			document.getElementById("no_google").textContent= "You must have an available internet connection to display graphs and tables. Make sure you are online."; 
		} 
  }
	
  try 
  {
    if (store) {
      drawStorage(cor, err, mis, tot, eff);  
    }
  }        
  catch (e)  { 
    document.getElementById("table_grp").innerHTML= "Your browser probably doesn't have support for the Web Storage Object or access to the Storage Object is disabled. Check your browser settings. In some browsers (IE11, Edge) Storage Object is not enabled when accessed in a local file (offline)."; 
  }       
}


/* async draw and display table and chart with user results (call google API)..
  (chart = PIE + table) => Displays the sum of: correct answers, errors, and missing values  
  res = total number of correct matches in task (sum)
  err = total errors in task (sum)
  mis = total missing values in task (sum) = Number of target stimuli not detected by the user */
function drawMissingReport(res, err, mis) 
{          
  document.getElementById("google_wrapper").style.display="block";  
  //    xxx  table = Displays the sum of: correct answers, errors, and missing values  xxx 
  var data = new google.visualization.DataTable();    // Create and populate the data table. 
  data.addColumn('string', 'Answer type');     // 1. col = ans array = must be string  
  data.addColumn('number', 'Sum');      // bellow are sums for: number of correct matches, errors, missing values = numbers = frequencies             
  data.addRow ( ["Correct", res] );
  data.addRow ( ["Errors", err] ); 
  data.addRow ( ["Missing", mis] );                                      
  options= {      
    'width': '50%',    
    'allowHtml': true, 
    'sort': 'enable',  
    'alternatingRowStyle': true              
  };           
  var elem= document.getElementById("table");
  elem.style.display = "block"; 
  new google.visualization.Table(elem).draw(data, options); 
  //    xxxxxx      PIE chart  => data are same   => draw PIE chart and table for correct, errors, missing values   xxxxxx 
  options= {   
   is3D: true, 
   legend: 'none',
   pieSliceText: 'value',
   tooltip: {text:'value'},    
   width: '100%',
	 title: 'Number of correct matches, errors and missing values', 
   chartArea: {width:'100%'}
  };           
  elem= document.getElementById("chart");   
  elem.style.display= "block"; 
  new google.visualization.PieChart(elem).draw(data, options);     // Create and draw the visualization. 
  document.getElementById("chart2").style.display= "none";
	document.getElementById("table2").style.display= "none";
}


/* async draw and display table and chart with user results (call google API)..
  (chart = PIE + table) => Displays the sum of: correct answers, errors, and missing values   
	 mov = number of moves, min_mov= minimum number of moves, 
	 eff = efficiency percentage, err= number of errors  */ 
function drawReport(mov, min_mov, eff, err) 
{          
  document.getElementById("google_wrapper").style.display="block";    
	
	//    xxxxxxxxxxxxxx      chart   xxxxxxxxxxxxxxxxx 
	var data = new google.visualization.DataTable();    // Create and populate the data table. 
  data.addColumn('string', 'Variable');     // 1. col (x-axis) = must be string  
  data.addColumn('number', 'Moves');      
  data.addColumn('number', 'Minimum number of moves'); 
  data.addColumn('number', 'Efficiency percentage');
	data.addColumn('number', 'Errors');
	data.addRow(["Result", mov, min_mov, eff, err]);                        
  options= {
   title: 'Efficiency percentage= ' + eff.toFixed(2) + '%. Total errors= ' + err,
   width: '100%'   
  };    
  document.getElementById('chart').style.display = "block";   
  new google.visualization.ColumnChart(document.getElementById('chart')).draw(data, options);     // Create and draw the visualization.      
  
	//    xxxxxxxxxxxxxx      table   xxxxxxxxxxxxxxxxx                             
  options= {      
    'width': '50%',    
    'allowHtml': true, 
    'sort': 'enable',  
    'alternatingRowStyle': true              
  };           
  var elem= document.getElementById("table");
  elem.title='Efficiency percentage= ' + eff.toFixed(2) + '%. Total errors= ' + err;
  elem.style.display= "block"; 
  new google.visualization.Table(elem).draw(data, options); // data are same

  // draw chart (chart2) and table (table2) group by shape count (lc..hc)
  // compute dependent variables => for each level (lc..hc)
  if ( hc > lc )
	{		
		data = new google.visualization.DataTable();    // Create and populate the data table. 
		data.addColumn('string', 'Shape count');     // 1. col = ans array = must be string  
		data.addColumn('number', 'Moves');  
		data.addColumn('number', 'Minimum number of moves');	
		data.addColumn('number', 'Efficiency percentage'); 
		data.addColumn('number', 'Errors');      
		var per, tmp; // Efficiency percentage; minimum number of moves at level
		for (var i in moves)  {   
			tmp= wc * 0.5 * i;
			per= 100 * tmp / moves[i]; // efficiency percent at i - level (i== number of shapes)
			data.addRow([ i.toString() + ". shapes",  moves[i], tmp, per, errors[i] ]); 
		} 											 
		options= {
			title: 'Results are grouped by the number of displayed shapes.',
			width: '100%',  
			hAxis: {
				title: 'Number of displayed shapes',
			}, 
			vAxis: {
				title: 'Score'
			}   
		};    
		document.getElementById("chart2").style.display = "block";   
		new google.visualization.ColumnChart(document.getElementById('chart2')).draw(data, options);     // Create and draw the visualization.                       					
		 //    xxxxxxxxxxxxxx  table2 group by number of shapes   xxxxxxxxx
		options= {      
			'width': '50%',    
			'allowHtml': true, 
			'sort': 'enable',  
			'alternatingRowStyle': true              
		};    // data are same         
		document.getElementById("table2").style.display= "block"; 
		new google.visualization.Table( document.getElementById("table2") ).draw(data, options); 
  }
	else 
	{
		document.getElementById("chart2").style.display= "none";
		document.getElementById("table2").style.display= "none";
	}
}


/*  use window.localStorage in client browser
    cor = number of correct matches in task (sum)
    err = total errors in task (sum)
    mis = total missing values in task (sum)
    tot= maximum possible score in task  
		eff = efficiency percentage  */
function drawStorage(cor,err,mis,tot,eff)   
{  	
	document.getElementById("table_grp").style.display="block";
  var oldItems = JSON.parse(localStorage.getItem("wm12-v1.0")) || []; 
  var id= oldItems.length+1;   
  // set new "record" 
  var newItem = {
    'id': id,
    'date': new Date(),      
    'score': cor, 
    'errors': err,       
    'missing': mis,  
		'max-score': tot, 
		'efficiency': (eff === null || mis > 0) ? "" : eff,		
    'show-correct' : demo ? "Yes": "No", 
		'start-level' : document.getElementById("lc").value,
    'final-level' : document.getElementById("hc").value,
    'within-level' : document.getElementById("wc").value,   
    'items': itemCnt,      
    'timer-time' : timer_enabled ? document.getElementById("timer").value : "",                   
    'emoji': emoji ? "Yes" : "No",       
    'full-color' : tcolor ? "Yes" : "No",
    'is-back' : is_back ? "Yes": "No",
		'is-forward' : is_forward ? "Yes": "No",
    'print-screen' : print 		
  };

  oldItems.push(newItem);

  localStorage.setItem("wm12-v1.0", JSON.stringify(oldItems));

  createTableJSON(document.getElementById("table_grp"), oldItems); 
   
  document.getElementById("score").textContent+= ". (ID=" + id + ")";
 
}


// convert JSON data dynamically to HTML Table using JavaScript - Dynamically Create table with rows in JavaScript
// downloaded and adapted from source: https://www.encodedna.com/javascript/populate-json-data-to-html-table-using-javascript.htm
function createTableJSON(elem, my_json) 
{  
  // EXTRACT VALUE FOR HTML HEADER. 
  var col = [];
  for (var i = 0; i < my_json.length; i++) {
    for (var key in my_json[i]) {
        if (col.indexOf(key) === -1) {
            col.push(key);
        }
    }
  } 
  var table = document.createElement("table");
  table.setAttribute("class", "my_table");    // table.className = 'my_table';
  // CREATE HTML TABLE HEADER ROW USING THE EXTRACTED HEADERS ABOVE.
  var tr = table.insertRow(-1);                   // TABLE ROW.
  for (var i = 0; i < col.length; i++) {
      var th = document.createElement("th");      // TABLE HEADER.
      th.innerHTML = col[i];
      tr.appendChild(th);
  }
  // ADD JSON DATA TO THE TABLE AS ROWS.
  for (var i = 0; i < my_json.length; i++) 
  {
    tr = table.insertRow(-1);
    for (var j = 0; j < col.length; j++) {
      var tabCell = tr.insertCell(-1);
      tabCell.innerHTML = my_json[i][col[j]];
    }
  }
  // FINALLY ADD THE NEWLY CREATED TABLE WITH JSON DATA TO A CONTAINER.
  elem.innerHTML= "";
  elem.appendChild(table);
}


// clear wm12 web browser storage data
function clrStorage()  
{  
  var cnt= localStorage.getItem("wm12-v1.0") ? JSON.parse(localStorage.getItem("wm12-v1.0")).length : 0;                                                        
  if (cnt === 0)  {
    alert("You have no wm12 data to delete");
    return;
  }  
  if ( !window.confirm("You have a total of " + cnt  + " wm12 results stored in your web browser. Continue?") ) { 
   return;
 }                                             
 if (window.confirm("Delete total saved wm12 results:  "  + cnt + ". This action cannot be undone. Final confirmation?") ) 
 { 
   window.localStorage.removeItem("wm12-v1.0"); 
   document.getElementById("store_cnt").textContent= "All data has been deleted. No data";
 }  
}
